--config:

local classcolor_yes_no = 1 -- use class color? (1 = yes; 0 = no)

PTBarSettings = {
	StatusTex = [[Interface\AddOns\PowerTrackerBar\Media\Bubble.tga]],
	PanelTex = [[Interface\AddOns\PowerTrackerBar\Media\Flat.tga]],
	font = [[Interface\AddOns\PowerTrackerBar\Media\font.ttf]],
	fontsize = 16, 		-- Font size
	barWidth = 181,		-- Bar width
	barHeight = 26,		-- Bar height
	anchor = {"CENTER", UIParent, "CENTER", -200, -50},
	
	-- Coloring config
	colors = {
		{0, 0, 0},			-- Backdrop color of panel
		{.2, .2, .2, 1},	-- Backdrop border color of panel	
		{0, 1, 0},			-- Color of statusbar
	},
}

-- end of config

local PTBarBG = CreateFrame("Frame", "PTBarBG", UIParent)
PTBarBG:SetHeight(PTBarSettings.barHeight)
PTBarBG:SetWidth(PTBarSettings.barWidth)
PTBarBG:SetPoint(unpack(PTBarSettings.anchor))
PTBarBG:SetBackdrop({
	bgFile = PTBarSettings.PanelTex, 
	edgeFile = PTBarSettings.PanelTex, 
	tile = false, tileSize = 0, edgeSize = 1, 
	insets = { left = -1, right = -1, top = -1, bottom = -1}
})
PTBarBG:SetBackdropColor(unpack(PTBarSettings.colors[1]))
PTBarBG:SetBackdropBorderColor(unpack(PTBarSettings.colors[2]))
PTBarBG:SetMovable(true)
PTBarBG:SetClampedToScreen(true)
PTBarBG:SetUserPlaced(true)


local PTBar = CreateFrame("StatusBar", "PTBar", PTBarBG)
PTBar:SetStatusBarTexture(PTBarSettings.StatusTex)
PTBar:SetPoint("TOPLEFT", PTBarBG, "TOPLEFT", 2, -2)
PTBar:SetPoint("BOTTOMRIGHT", PTBarBG, "BOTTOMRIGHT", -2, 2)

if classcolor_yes_no == 1 then
local _, class = UnitClass("player")
local r,g,b = RAID_CLASS_COLORS[class].r, RAID_CLASS_COLORS[class].g, RAID_CLASS_COLORS[class].b
PTBar:SetStatusBarColor(r,g,b, 0.7)
end
if classcolor_yes_no == 0 then
PTBar:SetStatusBarColor(unpack(PTBarSettings.colors[3]), 0.7)
end


local text = PTBar:CreateFontString(nil, "OVERLAY")
text:SetFont(PTBarSettings.font, PTBarSettings.fontsize, "THINOUTLINE")
text:SetPoint("CENTER", PTBarBG, "CENTER")

local TimeSinceLastUpdate = 1 -- bar
PTBar:SetScript("OnUpdate", function(self, elapsed)

	TimeSinceLastUpdate = TimeSinceLastUpdate + elapsed
		if (TimeSinceLastUpdate >= 1) then
			self:SetMinMaxValues(0, UnitPowerMax("player"))
			self:SetValue(UnitPower("player"))
			end
end)

local function p() -- text
	Power = UnitPower("player")
	
	if select(2, UnitClass("player")) == "MONK" then altpower = UnitPower("player", 12)
		elseif select(2, UnitClass("player")) == "ROGUE"  then altpower = UnitPower("player", 4)
		elseif select(2, UnitClass("player")) == "DRUID" then altpower = UnitPower("player", 4)
		elseif select(2, UnitClass("player")) == "PALADIN" then altpower = UnitPower("player", 9)
		else altpower = ""
	end
			
	if select(2, UnitClass("player")) == "ROGUE" then		
		anticipation_stacks = select(4, UnitBuff("player", GetSpellInfo(115189)))
		if not anticipation_stacks then anticipation_stacks = 0 end
	else anticipation_stacks = ""
	end
	
	if altpower == "" then		
		text:SetText(Power)
		elseif select(2, UnitClass("player")) == "ROGUE" then text:SetText(Power .. ' - (' .. altpower .. ') - (' .. anticipation_stacks .. ')')
		elseif select(2, UnitClass("player")) == "PALADIN" then text:SetText(altpower)
		else text:SetText(Power .. ' - (' .. altpower .. ')')
	end
end

PTBar:SetScript("OnEvent", p)
PTBar:RegisterEvent("UNIT_POWER")
PTBar:RegisterEvent("PLAYER_ENTERING_WORLD")
PTBar:RegisterEvent("UNIT_POWER_FREQUENT")
PTBar:RegisterEvent("UNIT_AURA")

local PTBmove = false 
local function POWER()
	if not PTBmove then
		PTBmove = true
		PTBarBG:EnableMouse(true)
		PTBarBG:RegisterForDrag("LeftButton")
		PTBarBG:SetScript("OnDragStart", PTBarBG.StartMoving)
		PTBarBG:SetScript("OnDragStop", PTBarBG.StopMovingOrSizing)
		PTBarBG:UnregisterEvent("UNIT_POWER")
		print("Power Tracker Bar unlocked, type /PTB to save.")
	elseif PTBmove == true then
		PTBarBG:EnableMouse(false)
		PTBmove = false
		print("Power Tracker Bar locked")
	end
end
SLASH_POWER1 = "/PTB"
SlashCmdList["POWER"] = POWER